// SymRetDlg.cpp : Implementation of CSymRetDlg

#include "stdafx.h"
#include "SymRetDlg.h"

#include <io.h>
#include <fcntl.h>
#include <sys\stat.h>

/////////////////////////////////////////////////////////////////////////////
// CSymRetDlg

static const GUID g_guidNull = { 0x0000000, 0x0000, 0x0000, { 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 } };

#define		MACRO_DOWNLOADING_TEXT				"Downloading..."
#define		MACRO_PENDING_TEXT					"Pending"
#define		MACRO_DONE_TEXT						"Done"
#define		MACRO_CABINETERR_TEXT				"Cabinet.dll not found!"
#define		MACRO_BCSTRANSNF_TEXT				"BCSTRANS not found!"
#define		MACRO_MODERR_TEXT					"Invalid image!"
#define		MACRO_DOWNLINT_TEXT					"Interrupted"
#define		MACRO_DOWNLERR_TEXT					"Error downloading!"
#define		MACRO_CABINETINITERR_TEXT			"Cabinet init error!"
#define		MACRO_CABINETAPIERR_TEXT			"Cabinet error!"
#define		MACRO_INVALIDDBG_TEXT				"Invalid DBG!"

LRESULT CSymRetDlg::OnInitDialog( UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled )
{
	// set the HWND in the callback obj.

	m_dcCallBack.m_hWnd = m_hWnd;

	// get hwnds of the controls.

	m_hwndFiles = GetDlgItem( IDC_FILES );
	m_hwndProgress = GetDlgItem( IDC_PROGRESS );
	m_hwndInfo = GetDlgItem( IDC_INFO );
	m_hwndOk = GetDlgItem( IDOK );

	// list control init.

	LVCOLUMN		lvCol = { LVCF_FMT | LVCF_TEXT | LVCF_SUBITEM, LVCFMT_LEFT, 0, "" };

	lvCol.pszText = "Image";
	lvCol.iSubItem = 0;
	ListView_InsertColumn( m_hwndFiles, 0, & lvCol );

	lvCol.pszText = "State";
	lvCol.iSubItem = 1;
	ListView_InsertColumn( m_hwndFiles, 1, & lvCol );

	// set the width of the list view cols.

	RECT		rectFiles;
	::GetClientRect( m_hwndFiles, & rectFiles );
	UINT		uiFilesWidth = rectFiles.right - rectFiles.left;

	ListView_SetColumnWidth( m_hwndFiles, 0, ( uiFilesWidth * 2 ) / 3 );
	ListView_SetColumnWidth( m_hwndFiles, 1, uiFilesWidth / 3 );

	// populate the list view ctrl.

	INT		size = m_pvcsFiles->size();
	for( int i=0; i<size; i ++ )
	{
		// insert the item.

		LVITEM			lvItem;
		::memset( & lvItem, 0, sizeof( lvItem ) );
		lvItem.mask = LVIF_TEXT;
		lvItem.iItem = i;
		lvItem.iSubItem = 0;
		lvItem.pszText = const_cast<CHAR*>( (*m_pvcsFiles)[ i ].c_str() );

		ListView_InsertItem( m_hwndFiles, & lvItem );

		// specify its state.

		ListView_SetItemText( m_hwndFiles, i, 1, MACRO_PENDING_TEXT );
	}

	// initialize the info tb font.

	if ( m_hCourierFont == NULL )
	{
		LOGFONT			lf;
		::memset( & lf, 0, sizeof( LOGFONT ) );

		lf.lfCharSet = DEFAULT_CHARSET;
		lf.lfHeight = -11;
		lf.lfWeight = 400;

		::strcpy( lf.lfFaceName, "Courier" );

		m_hCourierFont = ::CreateFontIndirect( & lf );
	}

	::SendMessage( m_hwndInfo, WM_SETFONT, (WPARAM) m_hCourierFont, (LPARAM) 1 );

	// initialize the info text box.

	SetInfo( "none", "none", m_pvcsFiles->size(), m_pvcsFiles->size() );

	// initialize the progress bar.

	::SendMessage( m_hwndProgress, PBM_SETRANGE, (WPARAM) 0, MAKELPARAM( 0, 100 ) );
	::SendMessage( m_hwndProgress, PBM_SETPOS, (WPARAM) 0, (LPARAM) 0 );

	// start the worker thread.

	m_dcCallBack.m_bDismiss = FALSE;
	m_hThread = ::CreateThread( NULL, 0, & WorkingThreadStart, (LPVOID) this, 0, & m_dwThreadId );

	::SetWindowText( m_hwndOk, "Stop" );

	// show the window.

	CenterWindow( m_pici->hwnd );
    ShowWindow( SW_SHOW );

	// return (the system will set the focus).

	return 1;
}

LRESULT CSymRetDlg::OnOk(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	// check out which action do.

	if ( m_hThread == NULL )
	{
		// close the dialog.
		EndDialog( 0 );
	}
	else
	{
		// start the thread termination.
		m_dcCallBack.m_bDismiss = TRUE;

		// disable this button.
		::EnableWindow( m_hwndOk, FALSE );
		::SetWindowText( m_hwndOk, "Pending" );
	}

	// return.
	return 0;
}

VOID CSymRetDlg::SetInfo( CHAR* pszCurrentFile, CHAR* pszDownloadPath, UINT uiFilesRemaining, UINT uiFilesTotal )
{
	// set text.

	CHAR		szFilesRemaining[ 64 ];
	::sprintf( szFilesRemaining, "%i", uiFilesRemaining );

	CHAR		szFilesTotal[ 64 ];
	::sprintf( szFilesTotal, "%i", uiFilesTotal );

	charstring	csText = charstring( "    Current File : " ) + pszCurrentFile + ".\r\n   Download Path : " + pszDownloadPath + ".\r\n Files Remaining : " + szFilesRemaining + " of " + szFilesTotal + ".";
	::SetWindowText( m_hwndInfo, csText.c_str() );

	// return.

	return;
}

/////////////////////////////////////////////////////////////////////////////

DWORD WINAPI CSymRetDlg::WorkingThreadStart( LPVOID lpParameter )
{
	CSymRetDlg*					_this = (CSymRetDlg*) lpParameter;
	HWND						hwnd = _this->m_hWnd;
	HMODULE						bcstrans = NULL;
	PFNINFOFromMOD				pfnINFOFromMOD = NULL;
	PFNBCSFromPDB				pfnBCSFromPDB = NULL;
	HMODULE						cabinet = NULL;
	PFNFDICreate				pfnFDICreate = NULL;
	PFNFDICopy					pfnFDICopy = NULL;
	PFNFDIDestroy				pfnFDIDestroy = NULL;
	BOOLEAN						bIsCabinetOk = FALSE;
	HFDI						context = NULL;

	// # # # We are Entering. # # #

	::SendMessage( hwnd, MACRO_MSG_RETRIEVER_THREADENTEREXIT, (WPARAM) TRUE, NULL );

	// # # # Main Loop. # # #

	bcstrans = ::LoadLibrary( _this->m_csBcsTransPath.c_str() );
	if ( bcstrans )
	{
		pfnINFOFromMOD = (PFNINFOFromMOD) ::GetProcAddress( bcstrans, "INFOFromMOD" );
		pfnBCSFromPDB = (PFNBCSFromPDB) ::GetProcAddress( bcstrans, "BCSFromPDB" );
	}

	cabinet = ::LoadLibrary( "cabinet.dll" );
	if ( cabinet )
	{
		pfnFDICreate = (PFNFDICreate) ::GetProcAddress( cabinet, "FDICreate" );
		pfnFDICopy = (PFNFDICopy) ::GetProcAddress( cabinet, "FDICopy" );
		pfnFDIDestroy = (PFNFDIDestroy) ::GetProcAddress( cabinet, "FDIDestroy" );

		if ( pfnFDICreate && pfnFDICopy && pfnFDIDestroy )
			bIsCabinetOk = TRUE;
	}

	BOOLEAN				dismiss = FALSE;

	while( TRUE )
	{
		if ( dismiss )
			break;

		// Retrieve the Next Image File Name.

		charstring			next = "";
		::SendMessage(
			hwnd,
			MACRO_MSG_RETRIEVER_GETNEXTIMAGEFN,
			(WPARAM) & next, NULL );

		if ( next.size() == 0 )
			break;

		// Process the File.

		charstring			status = MACRO_DONE_TEXT;

		BOOLEAN				bInfoAcquired = FALSE;
		DWORD				dwTimeDateStamp;
		DWORD				dwSizeOfImage;
		CHAR				szDbgFile[ MAX_PATH ] = "";
		BYTE				vbGuid[ MACRO_NEWMSPDB_GUIDLEN ];
		AGE					aAge;

		if ( bIsCabinetOk == FALSE )
		{
			status = MACRO_CABINETERR_TEXT;
		}
		else if ( pfnINFOFromMOD == NULL || pfnBCSFromPDB == NULL )
		{
			status = MACRO_BCSTRANSNF_TEXT;
		}
		else
		{
			PDBVALIDATEPARAMS			out;
			::memset( & out, 0, sizeof( out ) );

			ENUM_TRANSERR	err;

			BOOLEAN		res = pfnINFOFromMOD(
				TRANSGEN_FIRST,
				(CHAR*) next.c_str(),
				& out,
				szDbgFile, sizeof( szDbgFile ),
				& err );

			if ( res == FALSE )
			{
				status = MACRO_MODERR_TEXT;
			}
			else
			{
				// Set the Infos.

				bInfoAcquired = TRUE;
				dwTimeDateStamp = out.dwTimeDateStamp;
				dwSizeOfImage = out.dwSizeOfImage;
				::memcpy( vbGuid, & out.vbGuid, sizeof( vbGuid ) );
				aAge = out.aAge;
			}
		}

		if ( bInfoAcquired )
		{
			// Split the Filename.

			char		drive[_MAX_DRIVE];
			char		dir[_MAX_DIR];
			char		fname[_MAX_FNAME];
			char		ext[_MAX_EXT];

			::_splitpath( szDbgFile, drive, dir, fname, ext );

			// set the output dir.

			char		drive2[_MAX_DRIVE];
			char		dir2[_MAX_DIR];
			char		fname2[_MAX_FNAME];
			char		ext2[_MAX_EXT];

			::_splitpath( next.c_str(), drive2, dir2, fname2, ext2 );

			charstring			csLocalDir = charstring( drive2 ) + dir2;

			// Check whether we are dealing with a new VS7 PDB...

			if ( ::memcmp( vbGuid, & g_guidNull, sizeof( vbGuid ) ) != 0 )
			{
				GUID*			pguid;
				CHAR			szGuid[ 64 ];

				// Compose the name of the PDB.

				pguid = (GUID*) & vbGuid;
				::sprintf( szGuid, "%08lX%04X%04X%02X%02X%02X%02X%02X%02X%02X%02X%X",
					pguid->Data1,
					pguid->Data2,
					pguid->Data3,
					pguid->Data4[0],
					pguid->Data4[1],
					pguid->Data4[2],
					pguid->Data4[3],
					pguid->Data4[4],
					pguid->Data4[5],
					pguid->Data4[6],
					pguid->Data4[7],
					aAge );

				// Download the file.

				charstring			csUrl;

				csUrl = _this->m_csDownlSite + fname + ".pdb/" + szGuid + "/" + fname + ".pd_";

				DownloadAndDecompress(
					_this, csUrl, status, context, pfnFDICreate, pfnFDICopy, csLocalDir, fname, ".pdb" );

				if ( _this->m_dcCallBack.m_bDismiss )
					dismiss = TRUE;
			}
			else
			{
				// Convert to Strings.

				CHAR				szTimeDateStamp[ 0x20 ];
				CHAR				szSizeOfImage[ 0x20 ];

				::sprintf( szTimeDateStamp, "%X", dwTimeDateStamp );
				::sprintf( szSizeOfImage, "%X", dwSizeOfImage );

				// Compose the URL.

				charstring			csUrl;

				csUrl = _this->m_csDownlSite + fname + ".dbg/" + szTimeDateStamp + szSizeOfImage + "/" + fname + ".db_";

				BOOLEAN		copied = DownloadAndDecompress(
					_this, csUrl, status, context, pfnFDICreate, pfnFDICopy, csLocalDir, fname, ".dbg" );

				if ( _this->m_dcCallBack.m_bDismiss )
					dismiss = TRUE;

				// Continue with the PDB file.

				if ( copied )
				{
					// Call BCSTRANS.

					BCSTRANSPARAMS			params;
					::memset( & params, 0, sizeof( params ) );
					params.eTransLevel = TRANSLEVEL_GETDBGINFOONLY;

					ENUM_TRANSERR			err;

					BOOLEAN			r = pfnBCSFromPDB(
						TRANSGEN_FIRST,
						(CHAR*) _this->m_csOutFile.c_str(),
						"<null>", NULL, & params, & err );

					if ( r == FALSE )
					{
						status = MACRO_INVALIDDBG_TEXT;
					}
					else
					{
						CHAR		szNumbers[ 0x40 ];
						::sprintf( szNumbers, "%X%X",
							params.pdbvpValidate.sSig,
							params.pdbvpValidate.aAge );

						// Download the .PDB file.

						csUrl = _this->m_csDownlSite + fname + ".pdb/" + szNumbers + "/" + fname + ".pd_";

						DownloadAndDecompress(
							_this, csUrl, status, context, pfnFDICreate, pfnFDICopy, csLocalDir, fname, ".pdb" );

						if ( _this->m_dcCallBack.m_bDismiss )
							dismiss = TRUE;
					}
				}
			}
		}

		// Notify the Completion.

		::SendMessage(
			hwnd,
			MACRO_MSG_RETRIEVER_SETIMAGEFNSTATUS,
			(WPARAM) & next, (LPARAM) & status );
	}

	if ( context )
		pfnFDIDestroy( context );

	if ( bcstrans )
		::FreeLibrary( bcstrans );
	if ( cabinet )
		::FreeLibrary( cabinet );

	::SendMessage( hwnd, MACRO_MSG_RETRIEVER_ONPROGRESS, (WPARAM) 0, (LPARAM) 0 );

	// # # # We are Exiting... # # #

	::SendMessage( hwnd, MACRO_MSG_RETRIEVER_THREADENTEREXIT, (WPARAM) FALSE, NULL );

	// # # # Return. # # #

	return 0;
}

BOOLEAN CSymRetDlg::DownloadAndDecompress ( IN CSymRetDlg* _this, IN charstring& csUrl, OUT charstring& status, IN OUT HFDI& context, IN PFNFDICreate pfnFDICreate, IN PFNFDICopy pfnFDICopy, IN CONST charstring& csLocalDir, IN CONST CHAR* fname, IN CONST CHAR* ext )
{
	HWND						hwnd = _this->m_hWnd;
	BOOLEAN						copied = FALSE;

	// Download the File.

	::SendMessage( hwnd, MACRO_MSG_RETRIEVER_PRINTEVENT, (WPARAM) & csUrl, NULL );

	char		szResponseFile[ MAX_PATH ];
	HRESULT			hr = ::URLDownloadToCacheFile(
		NULL, csUrl.c_str(),
		szResponseFile, sizeof( szResponseFile ),
		BINDF_GETNEWESTVERSION,
		& _this->m_dcCallBack );

	if ( _this->m_dcCallBack.m_bDismiss )
	{
		status = MACRO_DOWNLINT_TEXT;
	}
	else if ( FAILED( hr ) )
	{
		status = MACRO_DOWNLERR_TEXT;
	}
	else
	{
		// Copy/Decompress the file.

		if ( context == NULL )
		{
			context = pfnFDICreate(
				& fnAlloc, & fnFree,
				& fnOpen, & fnRead, & fnWrite, & fnClose,
				& fnSeek,
				cpuUNKNOWN, & _this->strErf );
		}

		if ( context == NULL )
		{
			status = MACRO_CABINETINITERR_TEXT;
		}
		else
		{
			_this->m_csThisFile = charstring( fname ) + ext;
			_this->m_csOutFile = csLocalDir + _this->m_csThisFile;
			_this->m_bCopied = FALSE;

			BOOL			res = pfnFDICopy(
				context, "", szResponseFile,
				0, & fdiN, NULL, (PVOID) _this );

			if ( res == FALSE || _this->m_bCopied == FALSE )
			{
				status = MACRO_CABINETAPIERR_TEXT;
			}
			else
			{
				copied = TRUE;
			}
		}
	}

	// Return.

	return copied;
}

/////////////////////////////////////////////////////////////////////////////

void HUGE * FAR DIAMONDAPI CSymRetDlg::fnAlloc ( ULONG cb )
{
	return ::malloc( cb );
}

void FAR DIAMONDAPI CSymRetDlg::fnFree ( void HUGE *pv )
{
	::free( pv );
}

int FAR DIAMONDAPI CSymRetDlg::fnOpen ( char FAR *pszFile, int oflag, int pmode )
{
	return ::_open( pszFile, oflag, pmode );
}

UINT FAR DIAMONDAPI CSymRetDlg::fnRead ( int hf, void FAR *pv, UINT cb )
{
	return ::_read( hf, pv, cb );
}

UINT FAR DIAMONDAPI CSymRetDlg::fnWrite ( int hf, void FAR *pv, UINT cb )
{
	return ::_write( hf, pv, cb );
}

int FAR DIAMONDAPI CSymRetDlg::fnClose ( int hf )
{
	return ::_close( hf );
}

long FAR DIAMONDAPI CSymRetDlg::fnSeek ( int hf, long dist, int seektype )
{
	return ::_lseek( hf, dist, seektype );
}

int FAR DIAMONDAPI CSymRetDlg::fdiN( FDINOTIFICATIONTYPE fdint, PFDINOTIFICATION pfdin )
{
	CSymRetDlg*			_this = (CSymRetDlg*) pfdin->pv;

	int							retval = 0;

	// Which case ?

	switch( fdint )
	{
	case fdintCOPY_FILE:
		{
			if ( ::stricmp( pfdin->psz1, _this->m_csThisFile.c_str() ) )
				break;

			int			res = ::_open( _this->m_csOutFile.c_str(),
				_O_BINARY | _O_TRUNC | _O_CREAT | _O_WRONLY,
				_S_IREAD | _S_IWRITE );

			if ( res == -1 )
				retval = -1;
			else
				retval = res;
		}
		break;

	case fdintCLOSE_FILE_INFO:
		{
			::_close( pfdin->hf );
			_this->m_bCopied = TRUE;

			retval = TRUE;
		}
		break;
	}

	// Return.

	return retval;
}

/////////////////////////////////////////////////////////////////////////////

LRESULT CSymRetDlg::OnRetrieverThreadEnterExit( UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled )
{
	// handle the msg.
	BOOLEAN			active = (BOOLEAN) wParam;
	if ( active == FALSE )
	{
		// set the ok btn state.
		::SetWindowText( m_hwndOk, "Exit" );
		::EnableWindow( m_hwndOk, TRUE );
		::SetFocus( m_hwndOk );
		m_hThread = NULL;

		// set the info tb.
		SetInfo( "none", "none", 0, m_pvcsFiles->size() );
	}

	// return.
	return 0;
}

LRESULT CSymRetDlg::OnRetrieverGetNextImageFn( UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled )
{
	// handle the msg.

	charstring*				pcs = (charstring*) wParam;
	(*pcs) = "";

	if ( m_iCurrentFile < m_pvcsFiles->size() )
	{
		(*pcs) = (*m_pvcsFiles)[ m_iCurrentFile ];
		ListView_SetItemText( m_hwndFiles, m_iCurrentFile, 1, MACRO_DOWNLOADING_TEXT );
		m_iCurrentFile ++;
	}

	// return.
	return 0;
}

LRESULT CSymRetDlg::OnRetrieverPrintEvent( UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled )
{
	// handle the msg.

	charstring*				pcs = (charstring*) wParam;

	SetInfo(
		const_cast< CHAR* >( (*m_pvcsFiles)[ m_iCurrentFile - 1 ].c_str() ),
		const_cast< CHAR* >( pcs->c_str() ),
		m_pvcsFiles->size() - ( m_iCurrentFile - 1 ),
		m_pvcsFiles->size() );

	// return.
	return 0;
}

LRESULT CSymRetDlg::OnRetrieverSetImageFnStatus( UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled )
{
	// handle the msg.

	charstring*				pfn = (charstring*) wParam; // #NOTE# ignore this. read "m_iCurrentFile-1" instead...
	charstring*				pst = (charstring*) lParam;

	ListView_SetItemText( m_hwndFiles, m_iCurrentFile - 1, 1, const_cast< CHAR* >( pst->c_str() ) );

	// return.
	return 0;
}

LRESULT CSymRetDlg::OnRetrieverOnProgress( UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled )
{
	// handle the msg.

	ULONG		ulProgress = (ULONG) wParam;
	ULONG		ulProgressMax = (ULONG) lParam;

	ULONG		ulRetrProgress;

	if ( ulProgress && ulProgressMax )
		ulRetrProgress = ( 100 * ulProgress ) / ulProgressMax;
	else
		ulRetrProgress = 0;

	::SendMessage( m_hwndProgress, PBM_SETPOS, (WPARAM) ulRetrProgress, (LPARAM) 0 );

	// return.
	return 0;
}

/////////////////////////////////////////////////////////////////////////////
