// SymRetDlg.h : Declaration of the CSymRetDlg

#ifndef __SYMRETDLG_H__
#define __SYMRETDLG_H__

#include "resource.h"       // main symbols
#include <atlhost.h>
#include <shlobj.h>

#include "..\Include\bcstrans\bcstrpub_stripped.h"
#include "..\Include\cabsdk\FDI.H"

/////////////////////////////////////////////////////////////////////////////

#define MACRO_MSG_RETRIEVER_THREADENTEREXIT			( WM_USER + 0x70 )
#define MACRO_MSG_RETRIEVER_GETNEXTIMAGEFN			( WM_USER + 0x71 )
#define MACRO_MSG_RETRIEVER_PRINTEVENT				( WM_USER + 0x72 )
#define MACRO_MSG_RETRIEVER_SETIMAGEFNSTATUS		( WM_USER + 0x73 )
#define MACRO_MSG_RETRIEVER_ONPROGRESS				( WM_USER + 0x74 )

/////////////////////////////////////////////////////////////////////////////

typedef HFDI ( FAR DIAMONDAPI * PFNFDICreate)(PFNALLOC pfnalloc,
                              PFNFREE  pfnfree,
                              PFNOPEN  pfnopen,
                              PFNREAD  pfnread,
                              PFNWRITE pfnwrite,
                              PFNCLOSE pfnclose,
                              PFNSEEK  pfnseek,
                              int      cpuType,
                              PERF     perf);

typedef BOOL ( FAR DIAMONDAPI * PFNFDICopy)(HFDI          hfdi,
                            char FAR     *pszCabinet,
                            char FAR     *pszCabPath,
                            int           flags,
                            PFNFDINOTIFY  pfnfdin,
                            PFNFDIDECRYPT pfnfdid,
                            void FAR     *pvUser);

typedef BOOL ( FAR DIAMONDAPI * PFNFDIDestroy)(HFDI hfdi);

/////////////////////////////////////////////////////////////////////////////

struct SDownloadCallback : public IBindStatusCallback
{
	// Construction.

	SDownloadCallback ( HWND hWnd ) : m_bDismiss( FALSE ), m_hWnd( hWnd )
	{ }

	// Data.

	HWND			m_hWnd;
	BOOLEAN			m_bDismiss;

	// Interface.

	STDMETHOD(QueryInterface)(REFIID iid, void **ppvObject) { return E_NOINTERFACE; }
	STDMETHOD_(ULONG, AddRef)() { return 1; }
	STDMETHOD_(ULONG, Release)() { return 0; }

	virtual HRESULT STDMETHODCALLTYPE OnStartBinding( DWORD dwReserved, IBinding __RPC_FAR *pib) { return E_NOTIMPL; }
	virtual HRESULT STDMETHODCALLTYPE GetPriority( LONG __RPC_FAR *pnPriority) { return E_NOTIMPL; }
	virtual HRESULT STDMETHODCALLTYPE OnLowResource( DWORD reserved) { return E_NOTIMPL; }
	virtual HRESULT STDMETHODCALLTYPE OnStopBinding( HRESULT hresult, LPCWSTR szError) { return E_NOTIMPL; }
	virtual HRESULT STDMETHODCALLTYPE GetBindInfo( DWORD __RPC_FAR *grfBINDF, BINDINFO __RPC_FAR *pbindinfo) { return E_NOTIMPL; }
	virtual HRESULT STDMETHODCALLTYPE OnDataAvailable( DWORD grfBSCF, DWORD dwSize, FORMATETC __RPC_FAR *pformatetc, STGMEDIUM __RPC_FAR *pstgmed) { return E_NOTIMPL; }
	virtual HRESULT STDMETHODCALLTYPE OnObjectAvailable( REFIID riid, IUnknown __RPC_FAR *punk) { return E_NOTIMPL; }

	virtual HRESULT STDMETHODCALLTYPE OnProgress( ULONG ulProgress, ULONG ulProgressMax, ULONG ulStatusCode, LPCWSTR szStatusText)
	{
		if ( m_bDismiss == FALSE )
		{
			::SendMessage(
				m_hWnd,
				MACRO_MSG_RETRIEVER_ONPROGRESS,
				(WPARAM) ulProgress, (LPARAM) ulProgressMax );

			return S_OK;
		}
		else
			return E_ABORT;
	}
};

/////////////////////////////////////////////////////////////////////////////
// CSymRetDlg

class CSymRetDlg : public CDialogImpl<CSymRetDlg>
{
public:
	CSymRetDlg ( LPCMINVOKECOMMANDINFO pici, charstring_vector* pvcsFiles ) :
		m_pici( pici ), m_pvcsFiles( pvcsFiles ),
		m_hwndFiles( NULL ), m_hwndProgress( NULL ), m_hwndInfo( NULL ), m_hwndOk( NULL ),
		m_hCourierFont( NULL ),
		m_dcCallBack( NULL ),
		m_hThread( NULL ), m_dwThreadId( 0 ), m_iCurrentFile( 0 )
	{
		// initialize BCSTRANS path.

		CHAR			szDllPath[ MAX_PATH ] = "";
		::GetModuleFileName( _Module.GetModuleInstance(), szDllPath, sizeof( szDllPath ) );

		char		drive[_MAX_DRIVE];
		char		dir[_MAX_DIR];
		char		fname[_MAX_FNAME];
		char		ext[_MAX_EXT];
		::_splitpath( szDllPath, drive, dir, fname, ext );

		m_csBcsTransPath = charstring( drive ) + dir + "bcstrans.dll";

		// initialize MSDL site...

		m_csDownlSite = "http://msdl.microsoft.com/download/symbols/"; // #FIXME# hardcoded !!! #NOTE# append a slash at the end !!!
	}

	virtual ~CSymRetDlg ()
	{
		if ( m_hCourierFont )
			::DeleteObject( m_hCourierFont );
	}

	enum { IDD = IDD_SYMRETDLG };

BEGIN_MSG_MAP(CSymRetDlg)

	MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
	COMMAND_ID_HANDLER(IDOK, OnOk)
	COMMAND_ID_HANDLER(IDCANCEL, OnOk)

	MESSAGE_HANDLER(MACRO_MSG_RETRIEVER_THREADENTEREXIT, OnRetrieverThreadEnterExit)
	MESSAGE_HANDLER(MACRO_MSG_RETRIEVER_GETNEXTIMAGEFN, OnRetrieverGetNextImageFn)
	MESSAGE_HANDLER(MACRO_MSG_RETRIEVER_PRINTEVENT, OnRetrieverPrintEvent)
	MESSAGE_HANDLER(MACRO_MSG_RETRIEVER_SETIMAGEFNSTATUS, OnRetrieverSetImageFnStatus)
	MESSAGE_HANDLER(MACRO_MSG_RETRIEVER_ONPROGRESS, OnRetrieverOnProgress)

END_MSG_MAP()

	LRESULT OnInitDialog( UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled );
	LRESULT OnOk(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);

	LRESULT OnRetrieverThreadEnterExit( UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled );
	LRESULT OnRetrieverGetNextImageFn( UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled );
	LRESULT OnRetrieverPrintEvent( UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled );
	LRESULT OnRetrieverSetImageFnStatus( UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled );
	LRESULT OnRetrieverOnProgress( UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled );

// Implementation.
protected:

	// methods.

	VOID SetInfo( CHAR* pszCurrentFile, CHAR* pszDownloadPath, UINT uiFilesRemaining, UINT uiFilesTotal );

	static DWORD WINAPI WorkingThreadStart( LPVOID lpParameter );
	static BOOLEAN DownloadAndDecompress ( IN CSymRetDlg* _this, IN charstring& csUrl, OUT charstring& status, IN OUT HFDI& context, IN PFNFDICreate pfnFDICreate, IN PFNFDICopy pfnFDICopy, IN CONST charstring& csLocalDir, IN CONST CHAR* fname, IN CONST CHAR* ext );

	static void HUGE * FAR DIAMONDAPI fnAlloc ( ULONG cb );
	static void FAR DIAMONDAPI fnFree ( void HUGE *pv );
	static int FAR DIAMONDAPI fnOpen ( char FAR *pszFile, int oflag, int pmode );
	static UINT FAR DIAMONDAPI fnRead ( int hf, void FAR *pv, UINT cb );
	static UINT FAR DIAMONDAPI fnWrite ( int hf, void FAR *pv, UINT cb );
	static int FAR DIAMONDAPI fnClose ( int hf );
	static long FAR DIAMONDAPI fnSeek ( int hf, long dist, int seektype );

	static int FAR DIAMONDAPI fdiN( FDINOTIFICATIONTYPE fdint, PFDINOTIFICATION pfdin );

	// objects.

	SDownloadCallback			m_dcCallBack;

	// ### Cabinet DLL Stuff. ###

	ERF							strErf;

	// // Callback Passed Data -- --
	charstring		m_csThisFile;
	charstring		m_csOutFile;
	BOOLEAN			m_bCopied;
	// // -- --

	// data.

	INT							m_iCurrentFile;

	LPCMINVOKECOMMANDINFO		m_pici;
	charstring_vector*			m_pvcsFiles;
	HWND						m_hwndFiles, m_hwndProgress, m_hwndInfo, m_hwndOk;

	HFONT						m_hCourierFont;

	charstring					m_csBcsTransPath;
	charstring					m_csDownlSite;

	HANDLE						m_hThread;
	DWORD						m_dwThreadId;
};

#endif //__SYMRETDLG_H__
